#!/bin/sh

source "$(dirname $0)/samba.cfg"

INTERVAL=10

LOG=/tmp/smbsharemond.log

KILLFILE=/tmp/smsharemond.kill

if [ "$1" == "-k" ]; then
	touch "$KILLFILE"

	exit 0
fi

if [ "$1" != "-d" ]; then
	echo "Starting Samba Share Monitor daemon"
	nohup "$0" -d > /dev/null 2>&1 &
	exit 0
fi

s_echo() {
	echo "[$(date)] $@" >> $LOG
}

export PATH=/home/root/bin:$PATH

s_echo "Samba Share Monitor daemon started"

while sleep $INTERVAL; do
	if ! grep "$HOSTDIR_USB" /proc/mounts | grep -v -q jail; then
		if [ ! -d "$HOSTDIR_USB" ]; then
			s_echo "USB drive not mounted, waiting"
			continue
		fi

		s_echo "Remounting shares"

		for share in $SHARELIST
		do
			s_echo "Mounting share: $share"

			if ! mountshare $share "$HOSTDIR_USB/$share" >> $LOG; then
				s_echo "Mount failed: $share"
			fi
		done
	fi

	if [ -f "$KILLFILE" ]; then
		rm "$KILLFILE"

		s_echo "Exiting daemon"
		exit 0
	fi
done

